// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS inverter high level function to maintain power level by charging or discharging
 * </pre>
 *
 * Protobuf type {@code essmodule.PeakShaving}
 */
public final class PeakShaving extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.PeakShaving)
    PeakShavingOrBuilder {
private static final long serialVersionUID = 0L;
  // Use PeakShaving.newBuilder() to construct.
  private PeakShaving(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private PeakShaving() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new PeakShaving();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_PeakShaving_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_PeakShaving_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.PeakShaving.class, openfmb.essmodule.PeakShaving.Builder.class);
  }

  public static final int BASESHAVINGLIMIT_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue baseShavingLimit_;
  /**
   * <pre>
   * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
   * @return Whether the baseShavingLimit field is set.
   */
  @java.lang.Override
  public boolean hasBaseShavingLimit() {
    return baseShavingLimit_ != null;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
   * @return The baseShavingLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getBaseShavingLimit() {
    return baseShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : baseShavingLimit_;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getBaseShavingLimitOrBuilder() {
    return baseShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : baseShavingLimit_;
  }

  public static final int PEAKSHAVINGCTL_FIELD_NUMBER = 2;
  private com.google.protobuf.BoolValue peakShavingCtl_;
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
   * @return Whether the peakShavingCtl field is set.
   */
  @java.lang.Override
  public boolean hasPeakShavingCtl() {
    return peakShavingCtl_ != null;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
   * @return The peakShavingCtl.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getPeakShavingCtl() {
    return peakShavingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : peakShavingCtl_;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getPeakShavingCtlOrBuilder() {
    return peakShavingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : peakShavingCtl_;
  }

  public static final int PEAKSHAVINGLIMIT_FIELD_NUMBER = 3;
  private com.google.protobuf.FloatValue peakShavingLimit_;
  /**
   * <pre>
   * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
   * limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
   * @return Whether the peakShavingLimit field is set.
   */
  @java.lang.Override
  public boolean hasPeakShavingLimit() {
    return peakShavingLimit_ != null;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
   * limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
   * @return The peakShavingLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getPeakShavingLimit() {
    return peakShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : peakShavingLimit_;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
   * limit.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getPeakShavingLimitOrBuilder() {
    return peakShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : peakShavingLimit_;
  }

  public static final int SOCMANAGEMENTALLOWEDHIGHLIMIT_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue socManagementAllowedHighLimit_;
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
   * @return Whether the socManagementAllowedHighLimit field is set.
   */
  @java.lang.Override
  public boolean hasSocManagementAllowedHighLimit() {
    return socManagementAllowedHighLimit_ != null;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
   * @return The socManagementAllowedHighLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocManagementAllowedHighLimit() {
    return socManagementAllowedHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedHighLimit_;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocManagementAllowedHighLimitOrBuilder() {
    return socManagementAllowedHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedHighLimit_;
  }

  public static final int SOCMANAGEMENTALLOWEDLOWLIMIT_FIELD_NUMBER = 5;
  private com.google.protobuf.FloatValue socManagementAllowedLowLimit_;
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
   * @return Whether the socManagementAllowedLowLimit field is set.
   */
  @java.lang.Override
  public boolean hasSocManagementAllowedLowLimit() {
    return socManagementAllowedLowLimit_ != null;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
   * @return The socManagementAllowedLowLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocManagementAllowedLowLimit() {
    return socManagementAllowedLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedLowLimit_;
  }
  /**
   * <pre>
   * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
   * management is allowed.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocManagementAllowedLowLimitOrBuilder() {
    return socManagementAllowedLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedLowLimit_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (baseShavingLimit_ != null) {
      output.writeMessage(1, getBaseShavingLimit());
    }
    if (peakShavingCtl_ != null) {
      output.writeMessage(2, getPeakShavingCtl());
    }
    if (peakShavingLimit_ != null) {
      output.writeMessage(3, getPeakShavingLimit());
    }
    if (socManagementAllowedHighLimit_ != null) {
      output.writeMessage(4, getSocManagementAllowedHighLimit());
    }
    if (socManagementAllowedLowLimit_ != null) {
      output.writeMessage(5, getSocManagementAllowedLowLimit());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (baseShavingLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getBaseShavingLimit());
    }
    if (peakShavingCtl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPeakShavingCtl());
    }
    if (peakShavingLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getPeakShavingLimit());
    }
    if (socManagementAllowedHighLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getSocManagementAllowedHighLimit());
    }
    if (socManagementAllowedLowLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getSocManagementAllowedLowLimit());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.PeakShaving)) {
      return super.equals(obj);
    }
    openfmb.essmodule.PeakShaving other = (openfmb.essmodule.PeakShaving) obj;

    if (hasBaseShavingLimit() != other.hasBaseShavingLimit()) return false;
    if (hasBaseShavingLimit()) {
      if (!getBaseShavingLimit()
          .equals(other.getBaseShavingLimit())) return false;
    }
    if (hasPeakShavingCtl() != other.hasPeakShavingCtl()) return false;
    if (hasPeakShavingCtl()) {
      if (!getPeakShavingCtl()
          .equals(other.getPeakShavingCtl())) return false;
    }
    if (hasPeakShavingLimit() != other.hasPeakShavingLimit()) return false;
    if (hasPeakShavingLimit()) {
      if (!getPeakShavingLimit()
          .equals(other.getPeakShavingLimit())) return false;
    }
    if (hasSocManagementAllowedHighLimit() != other.hasSocManagementAllowedHighLimit()) return false;
    if (hasSocManagementAllowedHighLimit()) {
      if (!getSocManagementAllowedHighLimit()
          .equals(other.getSocManagementAllowedHighLimit())) return false;
    }
    if (hasSocManagementAllowedLowLimit() != other.hasSocManagementAllowedLowLimit()) return false;
    if (hasSocManagementAllowedLowLimit()) {
      if (!getSocManagementAllowedLowLimit()
          .equals(other.getSocManagementAllowedLowLimit())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasBaseShavingLimit()) {
      hash = (37 * hash) + BASESHAVINGLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getBaseShavingLimit().hashCode();
    }
    if (hasPeakShavingCtl()) {
      hash = (37 * hash) + PEAKSHAVINGCTL_FIELD_NUMBER;
      hash = (53 * hash) + getPeakShavingCtl().hashCode();
    }
    if (hasPeakShavingLimit()) {
      hash = (37 * hash) + PEAKSHAVINGLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getPeakShavingLimit().hashCode();
    }
    if (hasSocManagementAllowedHighLimit()) {
      hash = (37 * hash) + SOCMANAGEMENTALLOWEDHIGHLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getSocManagementAllowedHighLimit().hashCode();
    }
    if (hasSocManagementAllowedLowLimit()) {
      hash = (37 * hash) + SOCMANAGEMENTALLOWEDLOWLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getSocManagementAllowedLowLimit().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.PeakShaving parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.PeakShaving parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.PeakShaving parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.PeakShaving parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.PeakShaving prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS inverter high level function to maintain power level by charging or discharging
   * </pre>
   *
   * Protobuf type {@code essmodule.PeakShaving}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.PeakShaving)
      openfmb.essmodule.PeakShavingOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_PeakShaving_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_PeakShaving_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.PeakShaving.class, openfmb.essmodule.PeakShaving.Builder.class);
    }

    // Construct using openfmb.essmodule.PeakShaving.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      baseShavingLimit_ = null;
      if (baseShavingLimitBuilder_ != null) {
        baseShavingLimitBuilder_.dispose();
        baseShavingLimitBuilder_ = null;
      }
      peakShavingCtl_ = null;
      if (peakShavingCtlBuilder_ != null) {
        peakShavingCtlBuilder_.dispose();
        peakShavingCtlBuilder_ = null;
      }
      peakShavingLimit_ = null;
      if (peakShavingLimitBuilder_ != null) {
        peakShavingLimitBuilder_.dispose();
        peakShavingLimitBuilder_ = null;
      }
      socManagementAllowedHighLimit_ = null;
      if (socManagementAllowedHighLimitBuilder_ != null) {
        socManagementAllowedHighLimitBuilder_.dispose();
        socManagementAllowedHighLimitBuilder_ = null;
      }
      socManagementAllowedLowLimit_ = null;
      if (socManagementAllowedLowLimitBuilder_ != null) {
        socManagementAllowedLowLimitBuilder_.dispose();
        socManagementAllowedLowLimitBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_PeakShaving_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.PeakShaving getDefaultInstanceForType() {
      return openfmb.essmodule.PeakShaving.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.PeakShaving build() {
      openfmb.essmodule.PeakShaving result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.PeakShaving buildPartial() {
      openfmb.essmodule.PeakShaving result = new openfmb.essmodule.PeakShaving(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.PeakShaving result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.baseShavingLimit_ = baseShavingLimitBuilder_ == null
            ? baseShavingLimit_
            : baseShavingLimitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.peakShavingCtl_ = peakShavingCtlBuilder_ == null
            ? peakShavingCtl_
            : peakShavingCtlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.peakShavingLimit_ = peakShavingLimitBuilder_ == null
            ? peakShavingLimit_
            : peakShavingLimitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.socManagementAllowedHighLimit_ = socManagementAllowedHighLimitBuilder_ == null
            ? socManagementAllowedHighLimit_
            : socManagementAllowedHighLimitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.socManagementAllowedLowLimit_ = socManagementAllowedLowLimitBuilder_ == null
            ? socManagementAllowedLowLimit_
            : socManagementAllowedLowLimitBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.PeakShaving) {
        return mergeFrom((openfmb.essmodule.PeakShaving)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.PeakShaving other) {
      if (other == openfmb.essmodule.PeakShaving.getDefaultInstance()) return this;
      if (other.hasBaseShavingLimit()) {
        mergeBaseShavingLimit(other.getBaseShavingLimit());
      }
      if (other.hasPeakShavingCtl()) {
        mergePeakShavingCtl(other.getPeakShavingCtl());
      }
      if (other.hasPeakShavingLimit()) {
        mergePeakShavingLimit(other.getPeakShavingLimit());
      }
      if (other.hasSocManagementAllowedHighLimit()) {
        mergeSocManagementAllowedHighLimit(other.getSocManagementAllowedHighLimit());
      }
      if (other.hasSocManagementAllowedLowLimit()) {
        mergeSocManagementAllowedLowLimit(other.getSocManagementAllowedLowLimit());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getBaseShavingLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPeakShavingCtlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getPeakShavingLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getSocManagementAllowedHighLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getSocManagementAllowedLowLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue baseShavingLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> baseShavingLimitBuilder_;
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     * @return Whether the baseShavingLimit field is set.
     */
    public boolean hasBaseShavingLimit() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     * @return The baseShavingLimit.
     */
    public com.google.protobuf.FloatValue getBaseShavingLimit() {
      if (baseShavingLimitBuilder_ == null) {
        return baseShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : baseShavingLimit_;
      } else {
        return baseShavingLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public Builder setBaseShavingLimit(com.google.protobuf.FloatValue value) {
      if (baseShavingLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        baseShavingLimit_ = value;
      } else {
        baseShavingLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public Builder setBaseShavingLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (baseShavingLimitBuilder_ == null) {
        baseShavingLimit_ = builderForValue.build();
      } else {
        baseShavingLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public Builder mergeBaseShavingLimit(com.google.protobuf.FloatValue value) {
      if (baseShavingLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          baseShavingLimit_ != null &&
          baseShavingLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getBaseShavingLimitBuilder().mergeFrom(value);
        } else {
          baseShavingLimit_ = value;
        }
      } else {
        baseShavingLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public Builder clearBaseShavingLimit() {
      bitField0_ = (bitField0_ & ~0x00000001);
      baseShavingLimit_ = null;
      if (baseShavingLimitBuilder_ != null) {
        baseShavingLimitBuilder_.dispose();
        baseShavingLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getBaseShavingLimitBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getBaseShavingLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getBaseShavingLimitOrBuilder() {
      if (baseShavingLimitBuilder_ != null) {
        return baseShavingLimitBuilder_.getMessageOrBuilder();
      } else {
        return baseShavingLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : baseShavingLimit_;
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes below this limit, the ESS will charge to maintain this limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue baseShavingLimit = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getBaseShavingLimitFieldBuilder() {
      if (baseShavingLimitBuilder_ == null) {
        baseShavingLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getBaseShavingLimit(),
                getParentForChildren(),
                isClean());
        baseShavingLimit_ = null;
      }
      return baseShavingLimitBuilder_;
    }

    private com.google.protobuf.BoolValue peakShavingCtl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> peakShavingCtlBuilder_;
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     * @return Whether the peakShavingCtl field is set.
     */
    public boolean hasPeakShavingCtl() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     * @return The peakShavingCtl.
     */
    public com.google.protobuf.BoolValue getPeakShavingCtl() {
      if (peakShavingCtlBuilder_ == null) {
        return peakShavingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : peakShavingCtl_;
      } else {
        return peakShavingCtlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public Builder setPeakShavingCtl(com.google.protobuf.BoolValue value) {
      if (peakShavingCtlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        peakShavingCtl_ = value;
      } else {
        peakShavingCtlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public Builder setPeakShavingCtl(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (peakShavingCtlBuilder_ == null) {
        peakShavingCtl_ = builderForValue.build();
      } else {
        peakShavingCtlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public Builder mergePeakShavingCtl(com.google.protobuf.BoolValue value) {
      if (peakShavingCtlBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          peakShavingCtl_ != null &&
          peakShavingCtl_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getPeakShavingCtlBuilder().mergeFrom(value);
        } else {
          peakShavingCtl_ = value;
        }
      } else {
        peakShavingCtlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public Builder clearPeakShavingCtl() {
      bitField0_ = (bitField0_ & ~0x00000002);
      peakShavingCtl_ = null;
      if (peakShavingCtlBuilder_ != null) {
        peakShavingCtlBuilder_.dispose();
        peakShavingCtlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public com.google.protobuf.BoolValue.Builder getPeakShavingCtlBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPeakShavingCtlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getPeakShavingCtlOrBuilder() {
      if (peakShavingCtlBuilder_ != null) {
        return peakShavingCtlBuilder_.getMessageOrBuilder();
      } else {
        return peakShavingCtl_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : peakShavingCtl_;
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue peakShavingCtl = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getPeakShavingCtlFieldBuilder() {
      if (peakShavingCtlBuilder_ == null) {
        peakShavingCtlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getPeakShavingCtl(),
                getParentForChildren(),
                isClean());
        peakShavingCtl_ = null;
      }
      return peakShavingCtlBuilder_;
    }

    private com.google.protobuf.FloatValue peakShavingLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> peakShavingLimitBuilder_;
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     * @return Whether the peakShavingLimit field is set.
     */
    public boolean hasPeakShavingLimit() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     * @return The peakShavingLimit.
     */
    public com.google.protobuf.FloatValue getPeakShavingLimit() {
      if (peakShavingLimitBuilder_ == null) {
        return peakShavingLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : peakShavingLimit_;
      } else {
        return peakShavingLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public Builder setPeakShavingLimit(com.google.protobuf.FloatValue value) {
      if (peakShavingLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        peakShavingLimit_ = value;
      } else {
        peakShavingLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public Builder setPeakShavingLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (peakShavingLimitBuilder_ == null) {
        peakShavingLimit_ = builderForValue.build();
      } else {
        peakShavingLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public Builder mergePeakShavingLimit(com.google.protobuf.FloatValue value) {
      if (peakShavingLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          peakShavingLimit_ != null &&
          peakShavingLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getPeakShavingLimitBuilder().mergeFrom(value);
        } else {
          peakShavingLimit_ = value;
        }
      } else {
        peakShavingLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public Builder clearPeakShavingLimit() {
      bitField0_ = (bitField0_ & ~0x00000004);
      peakShavingLimit_ = null;
      if (peakShavingLimitBuilder_ != null) {
        peakShavingLimitBuilder_.dispose();
        peakShavingLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public com.google.protobuf.FloatValue.Builder getPeakShavingLimitBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getPeakShavingLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getPeakShavingLimitOrBuilder() {
      if (peakShavingLimitBuilder_ != null) {
        return peakShavingLimitBuilder_.getMessageOrBuilder();
      } else {
        return peakShavingLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : peakShavingLimit_;
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power goes above this limit, the ESS will discharge to maintain this
     * limit.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue peakShavingLimit = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getPeakShavingLimitFieldBuilder() {
      if (peakShavingLimitBuilder_ == null) {
        peakShavingLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getPeakShavingLimit(),
                getParentForChildren(),
                isClean());
        peakShavingLimit_ = null;
      }
      return peakShavingLimitBuilder_;
    }

    private com.google.protobuf.FloatValue socManagementAllowedHighLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socManagementAllowedHighLimitBuilder_;
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     * @return Whether the socManagementAllowedHighLimit field is set.
     */
    public boolean hasSocManagementAllowedHighLimit() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     * @return The socManagementAllowedHighLimit.
     */
    public com.google.protobuf.FloatValue getSocManagementAllowedHighLimit() {
      if (socManagementAllowedHighLimitBuilder_ == null) {
        return socManagementAllowedHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedHighLimit_;
      } else {
        return socManagementAllowedHighLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public Builder setSocManagementAllowedHighLimit(com.google.protobuf.FloatValue value) {
      if (socManagementAllowedHighLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socManagementAllowedHighLimit_ = value;
      } else {
        socManagementAllowedHighLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public Builder setSocManagementAllowedHighLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socManagementAllowedHighLimitBuilder_ == null) {
        socManagementAllowedHighLimit_ = builderForValue.build();
      } else {
        socManagementAllowedHighLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public Builder mergeSocManagementAllowedHighLimit(com.google.protobuf.FloatValue value) {
      if (socManagementAllowedHighLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          socManagementAllowedHighLimit_ != null &&
          socManagementAllowedHighLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocManagementAllowedHighLimitBuilder().mergeFrom(value);
        } else {
          socManagementAllowedHighLimit_ = value;
        }
      } else {
        socManagementAllowedHighLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public Builder clearSocManagementAllowedHighLimit() {
      bitField0_ = (bitField0_ & ~0x00000008);
      socManagementAllowedHighLimit_ = null;
      if (socManagementAllowedHighLimitBuilder_ != null) {
        socManagementAllowedHighLimitBuilder_.dispose();
        socManagementAllowedHighLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocManagementAllowedHighLimitBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getSocManagementAllowedHighLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocManagementAllowedHighLimitOrBuilder() {
      if (socManagementAllowedHighLimitBuilder_ != null) {
        return socManagementAllowedHighLimitBuilder_.getMessageOrBuilder();
      } else {
        return socManagementAllowedHighLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedHighLimit_;
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedHighLimit = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocManagementAllowedHighLimitFieldBuilder() {
      if (socManagementAllowedHighLimitBuilder_ == null) {
        socManagementAllowedHighLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocManagementAllowedHighLimit(),
                getParentForChildren(),
                isClean());
        socManagementAllowedHighLimit_ = null;
      }
      return socManagementAllowedHighLimitBuilder_;
    }

    private com.google.protobuf.FloatValue socManagementAllowedLowLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socManagementAllowedLowLimitBuilder_;
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     * @return Whether the socManagementAllowedLowLimit field is set.
     */
    public boolean hasSocManagementAllowedLowLimit() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     * @return The socManagementAllowedLowLimit.
     */
    public com.google.protobuf.FloatValue getSocManagementAllowedLowLimit() {
      if (socManagementAllowedLowLimitBuilder_ == null) {
        return socManagementAllowedLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedLowLimit_;
      } else {
        return socManagementAllowedLowLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public Builder setSocManagementAllowedLowLimit(com.google.protobuf.FloatValue value) {
      if (socManagementAllowedLowLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socManagementAllowedLowLimit_ = value;
      } else {
        socManagementAllowedLowLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public Builder setSocManagementAllowedLowLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socManagementAllowedLowLimitBuilder_ == null) {
        socManagementAllowedLowLimit_ = builderForValue.build();
      } else {
        socManagementAllowedLowLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public Builder mergeSocManagementAllowedLowLimit(com.google.protobuf.FloatValue value) {
      if (socManagementAllowedLowLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          socManagementAllowedLowLimit_ != null &&
          socManagementAllowedLowLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocManagementAllowedLowLimitBuilder().mergeFrom(value);
        } else {
          socManagementAllowedLowLimit_ = value;
        }
      } else {
        socManagementAllowedLowLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public Builder clearSocManagementAllowedLowLimit() {
      bitField0_ = (bitField0_ & ~0x00000010);
      socManagementAllowedLowLimit_ = null;
      if (socManagementAllowedLowLimitBuilder_ != null) {
        socManagementAllowedLowLimitBuilder_.dispose();
        socManagementAllowedLowLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocManagementAllowedLowLimitBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getSocManagementAllowedLowLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocManagementAllowedLowLimitOrBuilder() {
      if (socManagementAllowedLowLimitBuilder_ != null) {
        return socManagementAllowedLowLimitBuilder_.getMessageOrBuilder();
      } else {
        return socManagementAllowedLowLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socManagementAllowedLowLimit_;
      }
    }
    /**
     * <pre>
     * uint/1kW  If the supervised power is between the band defined by these two limits then SOC
     * management is allowed.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socManagementAllowedLowLimit = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocManagementAllowedLowLimitFieldBuilder() {
      if (socManagementAllowedLowLimitBuilder_ == null) {
        socManagementAllowedLowLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocManagementAllowedLowLimit(),
                getParentForChildren(),
                isClean());
        socManagementAllowedLowLimit_ = null;
      }
      return socManagementAllowedLowLimitBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.PeakShaving)
  }

  // @@protoc_insertion_point(class_scope:essmodule.PeakShaving)
  private static final openfmb.essmodule.PeakShaving DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.PeakShaving();
  }

  public static openfmb.essmodule.PeakShaving getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<PeakShaving>
      PARSER = new com.google.protobuf.AbstractParser<PeakShaving>() {
    @java.lang.Override
    public PeakShaving parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<PeakShaving> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<PeakShaving> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.PeakShaving getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

